<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import { Check, ChevronLgDown, ChevronLgUp, World } from 'slippers-ui/icons';
import type { Locale } from '@/types/base';

// Docs: https://i18n.nuxtjs.org/docs/composables/use-switch-locale-path
const switchLocalePath = useSwitchLocalePath();
const { locale: currentLocaleCode, locales: allLocales, t } = useI18n() as any;
const route = useRoute();

const currentLocale = allLocales.value.find((lang: Locale) => lang.code === currentLocaleCode.value);
const availableLocales = allLocales.value.filter((locale: Locale) =>
  useAvailableLanguages(route.path).includes(locale.code),
);

const showDropdown = ref(false);
const toggleDropdown = () => {
  showDropdown.value = !showDropdown.value;
};

// Handler for keydown events to close dropdown on Esc press
const handleKeydown = (event: KeyboardEvent) => {
  if (event.key === 'Escape' && showDropdown.value) {
    showDropdown.value = false;
  }
};

const container = ref<HTMLElement | null>(null);
// Handler for clicks outside the component
const handleClickOutside = (event: MouseEvent) => {
  if (showDropdown.value && container.value && !container.value.contains(event.target as Node)) {
    showDropdown.value = false;
  }
};

onMounted(() => {
  document.addEventListener('keydown', handleKeydown);
  document.addEventListener('click', handleClickOutside);
});

onBeforeUnmount(() => {
  document.removeEventListener('keydown', handleKeydown);
  document.removeEventListener('click', handleClickOutside);
});
</script>

<template>
  <div id="language-selector" ref="container" class="be-nav-language-selector">
    <!-- Language Selector Button -->
    <button
      class="be-nav-language-selector__dropdown-btn"
      :aria-label="t('langSelector.languageSelectorAria')"
      aria-haspopup="true"
      :aria-expanded="showDropdown"
      @click="toggleDropdown"
    >
      <SlpIcon :icon="World" size="sm" />
      <SlpTypography tag="span" variant="body2">
        {{ currentLocale?.langLabel }}: {{ currentLocale?.label }}
      </SlpTypography>
      <SlpIcon :icon="showDropdown ? ChevronLgUp : ChevronLgDown" />
    </button>
    <!-- Language Dropdown -->
    <div
      ref="dropdown"
      class="be-nav-language-selector__dropdown"
      :class="{ 'be-nav-language-selector__dropdown--hidden': !showDropdown }"
      role="menu"
    >
      <ul ref="languageSelectorList" class="be-nav-language-selector__list">
        <li v-for="locale in availableLocales" :key="locale.code" class="be-nav-language-selector__list-item">
          <a
            role="menuitemradio"
            class="be-nav-language-selector__item-button"
            :aria-checked="currentLocale && currentLocale.code === locale.code"
            tabindex="0"
            :href="switchLocalePath(locale.code)"
            data-ga-location="language-selector"
            :data-ga-name="locale.code"
          >
            <SlpTypography tag="span" variant="body1">{{ locale.label }} </SlpTypography>
            <SlpIcon v-if="currentLocale && currentLocale.code === locale.code" :icon="Check" />
          </a>
        </li>
      </ul>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.be-nav-language-selector {
  position: relative;

  &__dropdown-btn {
    display: flex;
    color: $color-text-50;
    gap: $spacing-8;
    align-items: center;
    justify-content: flex-start;
    padding: $spacing-8 0;
    border: none;
    font-size: $font-size-default;
    font-weight: $font-weight-normal;
    appearance: none;
    background: transparent;
    cursor: pointer;

    -webkit-touch-callout: none;
    -webkit-user-select: none;
    -khtml-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    svg {
      height: 14px;
      width: 14px;
    }
  }

  &__dropdown {
    position: absolute;
    bottom: 100%;
    background-color: $color-surface-50;
    min-width: 345px;
    border: 1px solid $color-surface-300;
    border-radius: 4px;
    opacity: 1;
    visibility: visible;
    transition: all 0.3s ease-in-out;

    &--hidden {
      opacity: 0;
      visibility: hidden;
    }
  }

  &__list {
    display: flex;
    flex-direction: column;
    width: 100%;
  }

  &__item {
    display: flex;
    transition: background-color 0.3s ease-in-out;

    &:hover {
      background-color: $color-surface-200;
    }

    &-button {
      color: $color-primary-200;
      display: flex;
      justify-content: space-between;
      padding: $spacing-8 $spacing-16;
      cursor: pointer;
      width: 100%;
      border: none;

      &:hover {
        text-decoration: none;
      }
    }
  }
}
</style>
